///
pub struct Service {
  connection_broker: nats::asynk::Connection,
  queue_broker: String,
}

impl std::fmt::Debug for Service {
  fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
    f.debug_struct("Service of api.kgon.identity").finish()
  }
}

impl Service {
  ///
  pub fn new(connection_broker: nats::asynk::Connection, queue_broker: String) -> Service {
    Service {
      connection_broker,
      queue_broker,
    }
  }

  pub async fn subscribe(&self) -> std::result::Result<(), std::boxed::Box<dyn std::error::Error>> {
    futures::try_join!(self.list_vendors(), self.list_games(), self.execute_game(),).map(|_| ())
  }

  async fn list_vendors(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }
  async fn list_games(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }

  async fn execute_game(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }
}
